﻿/*
 * lcd.c
 *
 * Created: 2013-01-25 오후 3:55:46
 *  Author: 강건일
 */ 




#include <avr/io.h>
#include <util/delay.h>

#include "lcdh.cpp"

#define LCD_PORT    PORTC
#define LCD_DDR     DDRC

//내부함수 
 static void  checkbusy(void);
 static void  write_command(char command);
 static void  write_data(char ch);

 //lcd disp 초기화 
 
 void LcdInit(void)
 {
    LCD_DDR = 0xFF;
   _delay_ms(15);
   write_command(0x30);
   _delay_ms(5);
   write_command(0x30);
   _delay_ms(1);
   write_command(0x32);

   LcdCommand(FUNSET);
   LcdCommand(DISP_OFF);
   LcdCommand(ALLCLR);
   LcdCommand(ENTMOD);

    LcdCommand(DISP_ON);            //화면을 켜다 

    }

   //LCD에 명령 출력하는 함수 
   //입력 :lcd.h정의된 명령사용 

   void LcdCommand(char command)
   {
     checkbusy();
	 write_command(command);
	 }

	 //현재 위치에 문자 하나를 출력한다.
	 //입력: ch- 화면에 쓸 문자 코드 

	 void LcdPutchar(char ch)
	 {
	   checkbusy();
	   write_data(ch);
	 }
	 //문자열 출력
	 //입력: str- 출력할 문자열

	 void LcdPuts(char* str)
	 { 
	  while(*str)  //*str 이 NULL문자가 아니면 루프돈다. 
	  {
	   LcdPutchar(*str);   //문자 *str을 화면에 출력 
	   str++;              //str이 다음 문자를 가르킴 
	   	   }
	   }

	   //글자쓸 위치로 이동 
	   //Line-행
	   //Pos-열 
	   void LcdMove(char line,char pos)
	   {
	    pos = (line << 6) + pos;
		pos |= 0x80;

		LcdCommand(pos);
		}

		//LCD에 내리는 명령코드
		 

		static void write_command(char command)
		{
		 char temp;
		 //상위 니블 

		 temp=(command & 0xF0)|0x04; //0x04: RS=0
		                             // RW=0,E=1
         LCD_PORT = temp;
		 LCD_PORT = temp & ~0x04;       //E=0

		 //하위 니블 

		 temp = (command << 4) | 0x04;
		 LCD_PORT = temp;
		 LCD_PORT = temp & ~0x04;
		 _delay_us(1);
		 }

		 //데이터 레지스터 명령쓰기 		 
		 //입력:ch-LCD에 쓸 데이터 
		 static void write_data(char ch)

		 {
		  unsigned char temp;

		  //상위니블 
          //
		  temp = (ch & 0xF0)|0x05;
          LCD_PORT = temp;
		  LCD_PORT = temp & ~0x04;

		  //하위니블
		  // 
		  temp = (ch << 4)|0x05;
		  LCD_PORT = temp;
		  LCD_PORT = temp & ~0x04;
		  }
		  //1ms 지연으로 BF플래그 검사 대체 

		  static void checkbusy ()
		  {
		   _delay_ms(20);
		  }






		 

